/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-16 19:40
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============

vector<int> z_function(string s) {
  int l = 0, r = 0, n = size(s);
  vector<int> z(n);
  for (int i = 1; i < n; i++) {
    if (i < r)
      z[i] = min(z[i - l], r - i);
    while (i + z[i] < n &&
           s[z[i]] == s[i + z[i]])
      z[i]++;
    if (i + z[i] > r)
      l = i, r = i + z[i] - 1;
  }
  return z;
}

const int INF = 1 << 29;
string s, rs;
vector<int> z, f, b;
int N, M;

template<typename T>
void show(string s, vector<T> v){
    cerr << s << endl;
    for(auto e: v)
        cerr << e << " ";
    cerr << endl;
}

void solve(){
    // Code goes here ...
    int cnt = 0;
    cin >> s >> M;
    N = ssize(s);
    rs = string(rbegin(s), rend(s));
    R(i, M){
        string word, rword;
        cin >> word;
        rword = string(rbegin(word), rend(word));

        f.assign(ssize(word) + 3, INF);
        b.assign(ssize(rword) + 3, INF);

        // front view
        z = z_function(word + "#" + s);
        auto zz = z | views::drop(ssize(word) + 1);
        /* z = vector<int>(begin(z) + ssize(word) + 1, end(z)); */
        R(i, ssize(zz))
            ckmin(f[zz[i]], (int) i);
        for(int i = ssize(word); i >= 0; i--)
            ckmin(f[i], f[i+1]);
        
        // back view
        z = z_function(rword + "#" + rs);
        zz = z | views::drop(ssize(rword) + 1);
        R(i, ssize(zz))
            ckmin(b[zz[i]], (int) i);
        for(int i = ssize(rword); i >= 0; i--)
            ckmin(b[i], b[i+1]);

        /* show("z", z); */
        /* show("f", f); */
        /* show("b", b); */

        F(i, 1, ssize(word)){
            int j = ssize(word) - i;
            if(ssize(s) - b[j] - f[i] >= ssize(word)){
                cnt++;
                cerr << "Found " << word << endl;
                break;
            }
        }
    }

    cout << cnt << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
